/*
 * $Id: GaussianRandom.java,v 1.1 2008/03/16 15:11:52 akabane Exp $
 */
package org.logical_paradox.petitbasic.sound;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.util.Map;
import java.util.TreeMap;

public class GaussianRandom {
    public static double brnd(double sig,double m/*,double[] r*/) {
        double r1,r2;
        r1=Math.random();r2=Math.random();
        return sig*Math.sqrt(-2*Math.log(r1))*Math.cos(2*3.14159*r2)+m;
//        r[1]=sig*Math.sqrt(-2*Math.log(r1))*Math.sin(2*3.14159*r2)+m;
        
    }
	public static final void main(String[] args) throws Exception {
		Map map = new TreeMap();
		final double SIG = 3.0d;
		final double MU = 0.0d;
		BigDecimal low = new BigDecimal(0);
		BigDecimal high = new BigDecimal(0);

		for(int i = 0; i < 100000; i++) {
			int ii = (int)(brnd(SIG, MU) * 100.0d);
			BigDecimal id = new BigDecimal((double)ii);
			id = id.divide(new BigDecimal(100.0d));
			
//			System.out.println(id.doubleValue());
			Integer count = (Integer)map.get(id);
			if(count == null) {
				count = new Integer(0);
			}
			count = new Integer(count.intValue()+1);
			map.put(id, count);

			if(low.compareTo(id) > 0) {
				low = id;
			}
			if(high.compareTo(id) < 0) {
				high = id;
			}
		}

		PrintWriter pw = new PrintWriter(new FileWriter("C:/sample.txt"));
		int begin = low.multiply(new BigDecimal(100)).intValue();
		int end = high.multiply(new BigDecimal(100)).intValue();

		for(int i = begin; i < end; i++) {
			BigDecimal v = new BigDecimal(i);
			v = v.divide(new BigDecimal(100));
			Integer count = (Integer)map.get(v);

			if(count == null) {
				count = new Integer(0);
			}
			pw.println("" + v + "\t" + count);
		}
		pw.flush();
		pw.close();
	}
}
